// -*- C++ -*-
/*!
 * @file RTCManager.i
 * @brief swig interface file for RTCManager
 * @date $Date$
 *
 * Copyright (c) 2004 Noriaki Ando <n-ando@aist.go.jp>
 *          Task-intelligence Research Group,
 *          Intelligent System Research Institute,
 *          National Institute of Industrial Science (AIST), Japan
 *          All rights reserved.
 *
 * $Id$
 */

%module RTCManager


%{
#include "rtm/idl/RTCManagerSkel.h"
%}

//%import "RTComponent.i"

namespace RTM
{
  class RTCManager
  {
  public:
    RTM::RtmRes load(const char* pathname, const char* initfunc);
    RTM::RtmRes unload(const char* pathname);
    //    RTM::RTComponent_ptr create_component(const char* comp_name,
    //					  CORBA::String_out instance_name);
    RTM::RtmRes delete_component(const char* instance_name);
    RTM::ComponentFactoryList* component_factory_list();
    RTM::RTCBaseList* component_list();
    //    RTM::RtmRes command(const char* cmd, CORBA::String_out ret);

  protected:
    RTCManager();
    virtual ~RTCManager();
  };
};
